import { TMessageMetadataJSON } from '../../../types';
export declare class MessageMetadata {
    protected readonly uuid: string;
    protected publishedAt: number | null;
    protected scheduledAt: number | null;
    protected scheduledCronFired: boolean;
    protected attempts: number;
    protected scheduledRepeatCount: number;
    protected expired: boolean;
    protected nextScheduledDelay: number;
    protected nextRetryDelay: number;
    constructor();
    setPublishedAt(timestamp: number): MessageMetadata;
    setScheduledAt(timestamp: number): MessageMetadata;
    setNextScheduledDelay(delay: number): MessageMetadata;
    getSetNextScheduledDelay(): number;
    setNextRetryDelay(delay: number): MessageMetadata;
    getSetNextRetryDelay(): number;
    hasDelay(): boolean;
    resetMessageScheduledRepeatCount(): MessageMetadata;
    incrAttempts(): number;
    setAttempts(attempts: number): MessageMetadata;
    setMessageScheduledCronFired(fired: boolean): MessageMetadata;
    incrMessageScheduledRepeatCount(): number;
    setExpired(expired: boolean): MessageMetadata;
    reset(): MessageMetadata;
    getPublishedAt(): number | null;
    getScheduledAt(): number | null;
    getAttempts(): number;
    getMessageScheduledRepeatCount(): number;
    getId(): string;
    hasScheduledCronFired(): boolean;
    hasExpired(): boolean;
    getSetExpired(ttl: number, createdAt: number): boolean;
    getSetNextDelay(): number;
    toJSON(): TMessageMetadataJSON;
}
